package cscie160.hw1;

/**
 * <p>
 * CSCIE160
 * <p>
 * Assignment 1: Elevator part 1
 * </p>
 * <p>
 * This is a partial simulation of an Elevator by using the
 * sweep algorithm. </p>
 *
 * <p> By David Cheung </p>
 * 
 * @author David Cheung
 */
public class Elevator extends Object
{

//constants:
/**
  * The maximum number of people in 
  * an Elevator. This is hardcoded to 10.
  */
	public final int Capacity=10;
/**
  * The number of floors in the building. This is hardcoded to 7.
  */
	public final int numOfFloors=7;
	
//variables

/** 
 * The current floor that the Elevator is on.
 */
	public int currentFloor;
/**
 * The current direction of the elevator: 1=up, -1=down and
 * 0=not moving.
 */
	public int currentDirection; 
	
/** The number of passengers currently in the elevator */
	public int numOfPassengers;
	
/** 
 * Stores the destination requests for each floor and the
 * value would be boolean. Therefore the size of this array
 * should be numOfFloors.
 */
	public boolean [] destRequests;

/**
 * Stores the number of passengers destined for each floor.
 * The size of array should be # of floor, and each
 * value is number of passengers.
 */
	public int [] numOfPassDestForEachFloor;
	
//Methods:

/**
 * <p>
 * Moves Elevator from its current floor to the next floor. 
 * This depends on which direction the floor moves. </p>
 * 
 * <p>
 * If the floor is at the top, this will switch the direction
 * of the floor to down (-1) and up (1) if the elevator is
 * at the lowest floor. </p>
 * <p>
 * Calls the stop function if there is a floor that needs to be 
 * stopped. </p>
 * <p>
 * Calls toString function at the end of this.
 *
 * @see Elevator#stop()
 * @see Elevator#toString()
 * 
 */
	public void move()
	{
		currentFloor=currentFloor + currentDirection;
		if (currentFloor == numOfFloors)
		{
			currentDirection=-1;
		}
		else if (currentFloor == 1)
		{
			currentDirection=1;
		}
		if (destRequests[currentFloor] == true || 
			numOfPassDestForEachFloor[currentFloor] >= 1)
		{
			this.stop();
		}
		System.out.println(this);
	}	

/**
 * Prints the current status of the elevator.
 * Called by move each time move is executed.
 *
 * @see Elevator#move()
 */
	public String toString	()
	{
		// Stores the number of passengers string.
		String numOfPassString;		
		String curFloorString;
		
		numOfPassString=new String();
		curFloorString= new String();
		
		numOfPassString="Currently " + numOfPassengers + " on board. \n";
		curFloorString = "Current Floor: "+ currentFloor +" \n" ;
		
		return numOfPassString + curFloorString;
	}
	
/**
 * <p>
 * Does not actually stop the elevator in real time but
 * just to allow the simulation to process the numbers 
 * when stop is called. </p>
 * <p>
 * Subtracts numOfPassengers from numOfPassDestForEachFloor[currentFloor]
 * and clears numOfPassDestForeachFloor to 0. </p>
 * <p>
 */
	public void stop()
	{
		System.out.println("Stopping on floor "+ currentFloor);
		//to some stuff here...
		int numPass;
		
		numPass= numOfPassDestForEachFloor[currentFloor];
			// Dummy variable to store the ppl leaving
			//  this floor.
		
		numOfPassengers= numOfPassengers - numPass;
			// subtract num of ppl in the elvator.			

		numOfPassDestForEachFloor[currentFloor]=0;
			//clear the ppl on that floor.
		
	}
	
/**
 * This increments numb of passenger destined there by one, and
 * increase the number of passengers in elevator by one.
 *
 * @param Floor  Destination floor for a passenger.
 */
	public void boardPassenger(int Floor)
	{
	   numOfPassDestForEachFloor[Floor]++;
	   numOfPassengers++;
	}

// Insert constructor

/**
 *	Initializes class by creating an array with size of
 * numOfFloors + 1. Sets initial direction to UP.
 * 
 */
	public Elevator ()
	{
		destRequests = new boolean[numOfFloors+1];
		numOfPassDestForEachFloor = new int[numOfFloors+1];
		//it's easier to keep this convention where array[floor]
		// is consistent, so initializing them would requre 1 more.
		currentDirection=1;
	}
	
/**
 *	Starts the main part of the class, start
 * with adding passengers and then use a FOR loop
 * to do a 1-round sweep. Note: I used a FOR loop instead of 
 * WHILE loop because FOR loop allows me to look at
 * the data after the program ends. Whereas WHILE loop will 
 * generate a lot of unnecessary data.
 */

	public static void main(String argv[])
	{
		Elevator myElevator;
		myElevator = new Elevator();
		myElevator.boardPassenger(2);
		myElevator.boardPassenger(3);

		for(int i=1;i<15;i++)
		{
			myElevator.move();
		}
	}

}
