package cscie160.hw2;
import cscie160.hw2.Elevator;
import cscie160.hw2.ElevatorFullException;

/**
 * <p>
 * CSCIE160
 * <p>
 * Assignment 2: Elevator part 2
 * </p>
 * <p>
 * Floor class: This class complements the elevator class for the
 * elevator project.
 * </p>
 *
 * <p> By David Cheung </p>
 * 
 * @author David Cheung
 */
public class Floor
{
// Data Members:
/**
 * numOfPassengers:
 * as specified in the HW, numOfPassengers is suppose to be
 * private--ie, Elevator class cannot acces it.
 * <p>
 * However, I used a toString method that will print out 
 * for debuging purposes.
 * <p>
 */
	private int numOfPassengers;
	
/**
 * This is the floor number of the floor.
 * <p>
 * This is used for debugging purposes only.
 */
	public int floorIdentifier;


//Methods

/**
 * unloadPassengers: <p>
 * This Method consists of 2 parts: <p>
 * The first part is from hw1's stop(). The 
 * second part is the new implemented exception
 * feature.
 * <p>
 * After unloading people in the elevator, this
 * function attempts to board passengers to the elevator
 * if sucessful, then method completes.
 * If elevator happens to be full, then this method
 * will cause Elevator's boardPassenger function to 
 * throw an exception. Thus the remaining passengers will
 * be left on the floor. <p>
 * If the exception was thrown, then a registerRequest to the
 * elevator will be initiated. (Done in Catch)
 */
	public void unloadPassengers (Elevator anElevator)
	{
		//this method will unload the passengers from the Elevator and then
		//load the passengers from the floor to the elevator.
		System.out.println("Stopping on floor "+ anElevator.currentFloor);
		/** subtract num of ppl in the elvator.			*/
		anElevator.numOfPassengers= anElevator.numOfPassengers 
		     - anElevator.numOfPassDestForEachFloor[anElevator.currentFloor];
		/** clear the ppl on that floor. */
		anElevator.numOfPassDestForEachFloor[anElevator.currentFloor]=0;
		
		
		/**
		 *Now put the ppl that are waiting on the floor into the Elevator.
		 *Assumes all the passengers want to go to the first level.
		 */	
		try
		{
			for(int i=1; i <= numOfPassengers;i=i)
			{
				anElevator.boardPassenger(1);
				numOfPassengers--;
			}
			
		}
		catch (ElevatorFullException eleFull)
		{
			System.out.println("Elevator Full!");
			/**Select an elevator request. */
			anElevator.registerRequest(anElevator.currentFloor);
		}
	}

/** 
 * loadPassengers
 * 
 * This is not called by the elevator, but used as test method
 * to load in passengers.
 *
 */	
	public void loadPassengers(Elevator myElevator,int numOfPeople)
	{
		numOfPassengers=numOfPassengers + numOfPeople;
		myElevator.registerRequest(floorIdentifier);
	
	}

/** 
 * toString
 * <p>
 * For debugging use. Returns the numOfPassengers for this
 * floor
 */
	public String toString()
	{
		return ""+numOfPassengers;
	}
//Constructor

/**
  * Floor constructor:
  * <p>
  * sets floorIdentifier.
  * 
  * @param i The floor number of the floor.
  */	
	public Floor(int i)
	{
		floorIdentifier=i;
	}
}
